<html>
<head>
<title>Ogre::D3D9HardwareBufferManagerBase Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1D3D9HardwareBufferManagerBase.html">D3D9HardwareBufferManagerBase</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-types">Protected Types</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="#pro-static-attribs">Static Protected Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::D3D9HardwareBufferManagerBase Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::D3D9HardwareBufferManagerBase" --><!-- doxytag: inherits="Ogre::HardwareBufferManagerBase" -->
<p>Implementation of <a class="el" href="classOgre_1_1HardwareBufferManager.html" title="Singleton wrapper for hardware buffer manager.">HardwareBufferManager</a> for D3D9.  
 <a href="classOgre_1_1D3D9HardwareBufferManagerBase.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreD3D9HardwareBufferManager_8h_source.html">OgreD3D9HardwareBufferManager.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::D3D9HardwareBufferManagerBase:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1D3D9HardwareBufferManagerBase__inherit__graph.gif" border="0" usemap="#Ogre_1_1D3D9HardwareBufferManagerBase_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1D3D9HardwareBufferManagerBase_inherit__map" id="Ogre_1_1D3D9HardwareBufferManagerBase_inherit__map">
<area shape="rect" id="node2" href="classOgre_1_1HardwareBufferManagerBase.html" title="Base definition of a hardware buffer manager." alt="" coords="21,83,251,112"/><area shape="rect" id="node4" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator..." alt="" coords="93,5,179,35"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1D3D9HardwareBufferManagerBase-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a88f21df1e7ee330033812ddeba4a08fa">BufferLicenseType</a> { <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a88f21df1e7ee330033812ddeba4a08faa372ccf538e8a6022bba092d2b47f4fdb">BLT_MANUAL_RELEASE</a>, 
<a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a88f21df1e7ee330033812ddeba4a08faa994cf0191de83556e3c1e6cf30cd6acb">BLT_AUTOMATIC_RELEASE</a>
 }</td></tr>
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1D3D9HardwareBufferManagerBase.html#a5c0739e90d3081e796672b92264d4835">D3D9HardwareBufferManagerBase</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1D3D9HardwareBufferManagerBase.html#ac7caabc88877b234f5e3e8deebddbb88">~D3D9HardwareBufferManagerBase</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1D3D9HardwareBufferManagerBase.html#ada99304b688c2ceff6fd4b8b63dad90f">createVertexBuffer</a> (size_t vertexSize, size_t numVerts, <a class="el" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630">HardwareBuffer::Usage</a> usage, bool useShadowBuffer=false)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Creates a vertex buffer.  <a href="#ada99304b688c2ceff6fd4b8b63dad90f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1HardwareIndexBufferSharedPtr.html">HardwareIndexBufferSharedPtr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1D3D9HardwareBufferManagerBase.html#a55643b623b8168fb98c58ce39281a70e">createIndexBuffer</a> (<a class="el" href="classOgre_1_1HardwareIndexBuffer.html#a25ba4923e015d46de162f7cc4c256326">HardwareIndexBuffer::IndexType</a> itype, size_t numIndexes, <a class="el" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630">HardwareBuffer::Usage</a> usage, bool useShadowBuffer=false)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a hardware vertex buffer.  <a href="#a55643b623b8168fb98c58ce39281a70e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__RenderSystem.html#ga00531851f476b9a8432258652828902a">RenderToVertexBufferSharedPtr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1D3D9HardwareBufferManagerBase.html#aff42262fe713059c776d8d17afd1515b">createRenderToVertexBuffer</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a render to vertex buffer.  <a href="#aff42262fe713059c776d8d17afd1515b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#aa8203be281c1d4f66efd3e5f9616962a">createVertexDeclaration</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Creates a new vertex declaration.  <a href="#aa8203be281c1d4f66efd3e5f9616962a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a95462f68508b75a7d87d0c5e496806fa">destroyVertexDeclaration</a> (<a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> *decl)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Destroys a vertex declaration.  <a href="#a95462f68508b75a7d87d0c5e496806fa"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classOgre_1_1VertexBufferBinding.html">VertexBufferBinding</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a061290f70a7b145768a09030ac8684bf">createVertexBufferBinding</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Creates a new <a class="el" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex declaration with the...">VertexBufferBinding</a>.  <a href="#a061290f70a7b145768a09030ac8684bf"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a8f392b28a07b9f8f6b70f3020598acfe">destroyVertexBufferBinding</a> (<a class="el" href="classOgre_1_1VertexBufferBinding.html">VertexBufferBinding</a> *binding)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Destroys a <a class="el" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex declaration with the...">VertexBufferBinding</a>.  <a href="#a8f392b28a07b9f8f6b70f3020598acfe"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a1deff999bf2f7fa437609fca417810e9">registerVertexBufferSourceAndCopy</a> (const <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &amp;sourceBuffer, const <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &amp;copy)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Registers a vertex buffer as a copy of another.  <a href="#a1deff999bf2f7fa437609fca417810e9"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <br class="typebreak"/>
<a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#aabe7d6ac6a04013f106656c76a0eb222">allocateVertexBufferCopy</a> (const <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &amp;sourceBuffer, <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a88f21df1e7ee330033812ddeba4a08fa">BufferLicenseType</a> licenseType, <a class="el" href="classOgre_1_1HardwareBufferLicensee.html">HardwareBufferLicensee</a> *licensee, bool copyData=false)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Allocates a copy of a given vertex buffer.  <a href="#aabe7d6ac6a04013f106656c76a0eb222"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#ace31f1bc14e398d1379b1e50af9f87c3">releaseVertexBufferCopy</a> (const <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &amp;bufferCopy)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Manually release a vertex buffer copy for others to subsequently use.  <a href="#ace31f1bc14e398d1379b1e50af9f87c3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a6530263f486220aa3040129240d3caed">touchVertexBufferCopy</a> (const <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &amp;bufferCopy)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Tell engine that the vertex buffer copy intent to reuse.  <a href="#a6530263f486220aa3040129240d3caed"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a33cb1e71d569f6c3b277c70bdea870c0">_freeUnusedBufferCopies</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Free all unused vertex buffer copies.  <a href="#a33cb1e71d569f6c3b277c70bdea870c0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a507f064fdba0dd61a438f61a2dafac26">_releaseBufferCopies</a> (bool forceFreeUnused=false)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Internal method for releasing all temporary buffers which have been allocated using BLT_AUTOMATIC_RELEASE; is called by OGRE.  <a href="#a507f064fdba0dd61a438f61a2dafac26"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a0de1e9752a1f55aadcc839a4c1633a2f">_forceReleaseBufferCopies</a> (const <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &amp;sourceBuffer)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Internal method that forces the release of copies of a given buffer.  <a href="#a0de1e9752a1f55aadcc839a4c1633a2f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a9f39d0b6878ef2827887a5fb5ba32ba4">_forceReleaseBufferCopies</a> (<a class="el" href="classOgre_1_1HardwareVertexBuffer.html">HardwareVertexBuffer</a> *sourceBuffer)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Internal method that forces the release of copies of a given buffer.  <a href="#a9f39d0b6878ef2827887a5fb5ba32ba4"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a29b2e243bab8522ae27ec23268ea154a">_notifyVertexBufferDestroyed</a> (<a class="el" href="classOgre_1_1HardwareVertexBuffer.html">HardwareVertexBuffer</a> *buf)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Notification that a hardware vertex buffer has been destroyed.  <a href="#a29b2e243bab8522ae27ec23268ea154a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#aa12ae6a67af715b2be80182bd05abb46">_notifyIndexBufferDestroyed</a> (<a class="el" href="classOgre_1_1HardwareIndexBuffer.html">HardwareIndexBuffer</a> *buf)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Notification that a hardware index buffer has been destroyed.  <a href="#aa12ae6a67af715b2be80182bd05abb46"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a421b197ca3a38da17e2eb1531a645fa2">operator new</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">operator new, with debug line info  <a href="#a421b197ca3a38da17e2eb1531a645fa2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ac4bdf968b7b9af8a5239a27da73d5711">operator new</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ab78a921e54419be677839cdf15d1f0b8">operator new</a> (size_t sz, void *ptr)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">placement operator new  <a href="#ab78a921e54419be677839cdf15d1f0b8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a4be37baef81876985aa1071ad5acc6dd">operator new[]</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">array operator new, with debug line info  <a href="#a4be37baef81876985aa1071ad5acc6dd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#afa2943846ba6a2b5824a12857139cf5e">operator new[]</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a8357fe4fb4849772b94baa4bf47c7ded">operator delete</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a1c727e879a260c37b00ce5505fe8e144">operator delete</a> (void *ptr, void *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#acb46d4b0a597156d9ba5abc39d127792">operator delete</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a93e6a86dde5483c053ca0f2a85bbfd6c">operator delete[]</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a595ea4c05da8aa987d3800e65d23355d">operator delete[]</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td colspan="2"><h2><a name="pro-types"></a>
Protected Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1set.html">set</a><br class="typebreak"/>
&lt; <a class="el" href="classOgre_1_1HardwareVertexBuffer.html">HardwareVertexBuffer</a> * &gt;<br class="typebreak"/>
::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#ac413284fee3eb42ef05be9a920da448b">VertexBufferList</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">WARNING: The following two members should place before all other members.  <a href="#ac413284fee3eb42ef05be9a920da448b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1set.html">set</a><br class="typebreak"/>
&lt; <a class="el" href="classOgre_1_1HardwareIndexBuffer.html">HardwareIndexBuffer</a> * &gt;<br class="typebreak"/>
::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a2b2a1446c08ef1bb58c47987b62d83d0">IndexBufferList</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1set.html">set</a>&lt; <a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> * &gt;<br class="typebreak"/>
::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#ab3ae22ef96c13dfa02878d27d592f3bc">VertexDeclarationList</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1set.html">set</a><br class="typebreak"/>
&lt; <a class="el" href="classOgre_1_1VertexBufferBinding.html">VertexBufferBinding</a> * &gt;<br class="typebreak"/>
::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a44e20d0e3ca12fa67e5003266a87af52">VertexBufferBindingList</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1multimap.html">multimap</a><br class="typebreak"/>
&lt; <a class="el" href="classOgre_1_1HardwareVertexBuffer.html">HardwareVertexBuffer</a> <br class="typebreak"/>
*, <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &gt;<br class="typebreak"/>
::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#ab1b16f5bb965056ed416ca0d7eedb991">FreeTemporaryVertexBufferMap</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Map from original buffer to temporary buffers.  <a href="#ab1b16f5bb965056ed416ca0d7eedb991"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1map.html">map</a><br class="typebreak"/>
&lt; <a class="el" href="classOgre_1_1HardwareVertexBuffer.html">HardwareVertexBuffer</a> <br class="typebreak"/>
*, <a class="el" href="classOgre_1_1HardwareBufferManagerBase_1_1VertexBufferLicense.html">VertexBufferLicense</a> &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#ac56a99f7b4b029db20fd8b94f1e82c13">TemporaryVertexBufferLicenseMap</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Map from temporary buffer to details of a license.  <a href="#ac56a99f7b4b029db20fd8b94f1e82c13"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1D3D9HardwareBufferManagerBase.html#a2e213585f8c49d8b803859e5c73209ee">createVertexDeclarationImpl</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Internal method for creates a new vertex declaration, may be overridden by certain rendering APIs.  <a href="#a2e213585f8c49d8b803859e5c73209ee"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1D3D9HardwareBufferManagerBase.html#aea810a50aa7e04aba62b15d6ba6417f9">destroyVertexDeclarationImpl</a> (<a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> *decl)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Internal method for destroys a vertex declaration, may be overridden by certain rendering APIs.  <a href="#aea810a50aa7e04aba62b15d6ba6417f9"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a4be16779dfe2b99fc3395bfe66ba4b4d">destroyAllDeclarations</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Internal method for destroys all vertex declarations.  <a href="#a4be16779dfe2b99fc3395bfe66ba4b4d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a995a5db6b774e98b46c598dcb569f983">destroyAllBindings</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Internal method for destroys all vertex buffer bindings.  <a href="#a995a5db6b774e98b46c598dcb569f983"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classOgre_1_1VertexBufferBinding.html">VertexBufferBinding</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a36d7b275f4a2b39b27f55ace09140d03">createVertexBufferBindingImpl</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Internal method for creates a new <a class="el" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex declaration with the...">VertexBufferBinding</a>, may be overridden by certain rendering APIs.  <a href="#a36d7b275f4a2b39b27f55ace09140d03"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a39d2f9bd9b2388498b2143fb7c24710c">destroyVertexBufferBindingImpl</a> (<a class="el" href="classOgre_1_1VertexBufferBinding.html">VertexBufferBinding</a> *binding)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Internal method for destroys a <a class="el" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex declaration with the...">VertexBufferBinding</a>, may be overridden by certain rendering APIs.  <a href="#a39d2f9bd9b2388498b2143fb7c24710c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <br class="typebreak"/>
<a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#ac3cb89b74c26e42415d599b59079f5d7">makeBufferCopy</a> (const <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &amp;source, <a class="el" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630">HardwareBuffer::Usage</a> usage, bool useShadowBuffer)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Creates a new buffer as a copy of the source, does not copy data.  <a href="#ac3cb89b74c26e42415d599b59079f5d7"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#ac413284fee3eb42ef05be9a920da448b">VertexBufferList</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a6a99117e4adc55561ec0eb36617115a4">mVertexBuffers</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a2b2a1446c08ef1bb58c47987b62d83d0">IndexBufferList</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a458d12d5abfa8d8971a4c4c6b214f799">mIndexBuffers</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#ab3ae22ef96c13dfa02878d27d592f3bc">VertexDeclarationList</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#ab93e6c8ebe86328233d604c78f9cbb7b">mVertexDeclarations</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a44e20d0e3ca12fa67e5003266a87af52">VertexBufferBindingList</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a30d13bdd51fd0ffb1b2f5cc13bc15786">mVertexBufferBindings</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#ab1b16f5bb965056ed416ca0d7eedb991">FreeTemporaryVertexBufferMap</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#ac5339ff98d67f523eb88f9d1b29567d9">mFreeTempVertexBufferMap</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Map of current available temp buffers.  <a href="#ac5339ff98d67f523eb88f9d1b29567d9"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#ac56a99f7b4b029db20fd8b94f1e82c13">TemporaryVertexBufferLicenseMap</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a811086c11e14fa760b42ea958884804e">mTempVertexBufferLicenses</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Map of currently licensed temporary buffers.  <a href="#a811086c11e14fa760b42ea958884804e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a98d9ba3a449e791f89a53d7fcf89c00a">mUnderUsedFrameCount</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Number of frames elapsed since temporary buffers utilization was above half the available.  <a href="#a98d9ba3a449e791f89a53d7fcf89c00a"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-static-attribs"></a>
Static Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static const size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#afd420f56dc09d1e9975179e2ffe824ca">UNDER_USED_FRAME_THRESHOLD</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Number of frames to wait before free unused temporary buffers.  <a href="#afd420f56dc09d1e9975179e2ffe824ca"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static const size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a66f8e4f014fc41a52f35f7c0b03569e0">EXPIRED_DELAY_FRAME_THRESHOLD</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Frame delay for BLT_AUTOMATIC_RELEASE temporary buffers.  <a href="#a66f8e4f014fc41a52f35f7c0b03569e0"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Implementation of <a class="el" href="classOgre_1_1HardwareBufferManager.html" title="Singleton wrapper for hardware buffer manager.">HardwareBufferManager</a> for D3D9. </p>

<p>Definition at line <a class="el" href="OgreD3D9HardwareBufferManager_8h_source.html#l00037">37</a> of file <a class="el" href="OgreD3D9HardwareBufferManager_8h_source.html">OgreD3D9HardwareBufferManager.h</a>.</p>
</div><hr/><h2>Member Typedef Documentation</h2>
<a class="anchor" id="ab1b16f5bb965056ed416ca0d7eedb991"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::FreeTemporaryVertexBufferMap" ref="ab1b16f5bb965056ed416ca0d7eedb991" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1multimap.html">multimap</a>&lt;<a class="el" href="classOgre_1_1HardwareVertexBuffer.html">HardwareVertexBuffer</a>*, <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a>&gt;::type <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#ab1b16f5bb965056ed416ca0d7eedb991">Ogre::HardwareBufferManagerBase::FreeTemporaryVertexBufferMap</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Map from original buffer to temporary buffers. </p>

<p>Definition at line <a class="el" href="OgreHardwareBufferManager_8h_source.html#l00187">187</a> of file <a class="el" href="OgreHardwareBufferManager_8h_source.html">OgreHardwareBufferManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="a2b2a1446c08ef1bb58c47987b62d83d0"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::IndexBufferList" ref="a2b2a1446c08ef1bb58c47987b62d83d0" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1set.html">set</a>&lt;<a class="el" href="classOgre_1_1HardwareIndexBuffer.html">HardwareIndexBuffer</a>*&gt;::type <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a2b2a1446c08ef1bb58c47987b62d83d0">Ogre::HardwareBufferManagerBase::IndexBufferList</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreHardwareBufferManager_8h_source.html#l00120">120</a> of file <a class="el" href="OgreHardwareBufferManager_8h_source.html">OgreHardwareBufferManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac56a99f7b4b029db20fd8b94f1e82c13"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::TemporaryVertexBufferLicenseMap" ref="ac56a99f7b4b029db20fd8b94f1e82c13" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1map.html">map</a>&lt;<a class="el" href="classOgre_1_1HardwareVertexBuffer.html">HardwareVertexBuffer</a>*, <a class="el" href="classOgre_1_1HardwareBufferManagerBase_1_1VertexBufferLicense.html">VertexBufferLicense</a>&gt;::type <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#ac56a99f7b4b029db20fd8b94f1e82c13">Ogre::HardwareBufferManagerBase::TemporaryVertexBufferLicenseMap</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Map from temporary buffer to details of a license. </p>

<p>Definition at line <a class="el" href="OgreHardwareBufferManager_8h_source.html#l00191">191</a> of file <a class="el" href="OgreHardwareBufferManager_8h_source.html">OgreHardwareBufferManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="a44e20d0e3ca12fa67e5003266a87af52"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::VertexBufferBindingList" ref="a44e20d0e3ca12fa67e5003266a87af52" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1set.html">set</a>&lt;<a class="el" href="classOgre_1_1VertexBufferBinding.html">VertexBufferBinding</a>*&gt;::type <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a44e20d0e3ca12fa67e5003266a87af52">Ogre::HardwareBufferManagerBase::VertexBufferBindingList</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreHardwareBufferManager_8h_source.html#l00126">126</a> of file <a class="el" href="OgreHardwareBufferManager_8h_source.html">OgreHardwareBufferManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac413284fee3eb42ef05be9a920da448b"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::VertexBufferList" ref="ac413284fee3eb42ef05be9a920da448b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1set.html">set</a>&lt;<a class="el" href="classOgre_1_1HardwareVertexBuffer.html">HardwareVertexBuffer</a>*&gt;::type <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#ac413284fee3eb42ef05be9a920da448b">Ogre::HardwareBufferManagerBase::VertexBufferList</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>WARNING: The following two members should place before all other members. </p>
<p>Members destruct order is very important here, because destructing other members will cause notify back to this class, and then will access to this two members. </p>

<p>Definition at line <a class="el" href="OgreHardwareBufferManager_8h_source.html#l00119">119</a> of file <a class="el" href="OgreHardwareBufferManager_8h_source.html">OgreHardwareBufferManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab3ae22ef96c13dfa02878d27d592f3bc"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::VertexDeclarationList" ref="ab3ae22ef96c13dfa02878d27d592f3bc" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1set.html">set</a>&lt;<a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a>*&gt;::type <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#ab3ae22ef96c13dfa02878d27d592f3bc">Ogre::HardwareBufferManagerBase::VertexDeclarationList</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreHardwareBufferManager_8h_source.html#l00125">125</a> of file <a class="el" href="OgreHardwareBufferManager_8h_source.html">OgreHardwareBufferManager.h</a>.</p>

</div>
</div>
<hr/><h2>Member Enumeration Documentation</h2>
<a class="anchor" id="a88f21df1e7ee330033812ddeba4a08fa"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::BufferLicenseType" ref="a88f21df1e7ee330033812ddeba4a08fa" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a88f21df1e7ee330033812ddeba4a08fa">Ogre::HardwareBufferManagerBase::BufferLicenseType</a><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl><dt><b>Enumerator: </b></dt><dd><table border="0" cellspacing="2" cellpadding="0">
<tr><td valign="top"><em><a class="anchor" id="a88f21df1e7ee330033812ddeba4a08faa372ccf538e8a6022bba092d2b47f4fdb"></a><!-- doxytag: member="BLT_MANUAL_RELEASE" ref="a88f21df1e7ee330033812ddeba4a08faa372ccf538e8a6022bba092d2b47f4fdb" args="" -->BLT_MANUAL_RELEASE</em>&nbsp;</td><td>
<p>Licensee will only release buffer when it says so. </p>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="a88f21df1e7ee330033812ddeba4a08faa994cf0191de83556e3c1e6cf30cd6acb"></a><!-- doxytag: member="BLT_AUTOMATIC_RELEASE" ref="a88f21df1e7ee330033812ddeba4a08faa994cf0191de83556e3c1e6cf30cd6acb" args="" -->BLT_AUTOMATIC_RELEASE</em>&nbsp;</td><td>
<p>Licensee can have license revoked. </p>
</td></tr>
</table>
</dd>
</dl>

<p>Definition at line <a class="el" href="OgreHardwareBufferManager_8h_source.html#l00153">153</a> of file <a class="el" href="OgreHardwareBufferManager_8h_source.html">OgreHardwareBufferManager.h</a>.</p>

</div>
</div>
<hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a5c0739e90d3081e796672b92264d4835"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::D3D9HardwareBufferManagerBase" ref="a5c0739e90d3081e796672b92264d4835" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1D3D9HardwareBufferManagerBase.html#a5c0739e90d3081e796672b92264d4835">Ogre::D3D9HardwareBufferManagerBase::D3D9HardwareBufferManagerBase</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="ac7caabc88877b234f5e3e8deebddbb88"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::~D3D9HardwareBufferManagerBase" ref="ac7caabc88877b234f5e3e8deebddbb88" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1D3D9HardwareBufferManagerBase.html#ac7caabc88877b234f5e3e8deebddbb88">Ogre::D3D9HardwareBufferManagerBase::~D3D9HardwareBufferManagerBase</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a0de1e9752a1f55aadcc839a4c1633a2f"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::_forceReleaseBufferCopies" ref="a0de1e9752a1f55aadcc839a4c1633a2f" args="(const HardwareVertexBufferSharedPtr &amp;sourceBuffer)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a0de1e9752a1f55aadcc839a4c1633a2f">Ogre::HardwareBufferManagerBase::_forceReleaseBufferCopies</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &amp;&#160;</td>
          <td class="paramname"><em>sourceBuffer</em></td><td>)</td>
          <td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Internal method that forces the release of copies of a given buffer. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This usually means that the buffer which the copies are based on has been changed in some fundamental way, and the owner of the original wishes to make that known so that new copies will reflect the changes. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">sourceBuffer</td><td>the source buffer as a shared pointer. <a class="el" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a> buffer copies created from the source buffer are deleted. </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented in <a class="el" href="classOgre_1_1HardwareBufferManager.html#ab523a5b31c88599812538441b7e37775">Ogre::HardwareBufferManager</a>.</p>

<p>Referenced by <a class="el" href="OgreHardwareBufferManager_8h_source.html#l00477">Ogre::HardwareBufferManager::_forceReleaseBufferCopies()</a>.</p>

</div>
</div>
<a class="anchor" id="a9f39d0b6878ef2827887a5fb5ba32ba4"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::_forceReleaseBufferCopies" ref="a9f39d0b6878ef2827887a5fb5ba32ba4" args="(HardwareVertexBuffer *sourceBuffer)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a0de1e9752a1f55aadcc839a4c1633a2f">Ogre::HardwareBufferManagerBase::_forceReleaseBufferCopies</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1HardwareVertexBuffer.html">HardwareVertexBuffer</a> *&#160;</td>
          <td class="paramname"><em>sourceBuffer</em></td><td>)</td>
          <td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Internal method that forces the release of copies of a given buffer. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This usually means that the buffer which the copies are based on has been changed in some fundamental way, and the owner of the original wishes to make that known so that new copies will reflect the changes. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">sourceBuffer</td><td>the source buffer as a pointer. <a class="el" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a> buffer copies created from the source buffer are deleted. </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented in <a class="el" href="classOgre_1_1HardwareBufferManager.html#a0da9a2c9a66030d32c90871191da0b6a">Ogre::HardwareBufferManager</a>.</p>

</div>
</div>
<a class="anchor" id="a33cb1e71d569f6c3b277c70bdea870c0"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::_freeUnusedBufferCopies" ref="a33cb1e71d569f6c3b277c70bdea870c0" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a33cb1e71d569f6c3b277c70bdea870c0">Ogre::HardwareBufferManagerBase::_freeUnusedBufferCopies</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Free all unused vertex buffer copies. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This method free all temporary vertex buffers that not in used. In normally, temporary vertex buffers are subsequently stored and can be made available for other purposes later without incurring the cost of construction / destruction. But in some cases you want to free them to save hardware memory (e.g. application was runs in a long time, you might free temporary buffers periodically to avoid memory overload). </dd></dl>

<p>Reimplemented in <a class="el" href="classOgre_1_1HardwareBufferManager.html#a9a2793066da237001972061b76930c95">Ogre::HardwareBufferManager</a>.</p>

<p>Referenced by <a class="el" href="OgreHardwareBufferManager_8h_source.html#l00467">Ogre::HardwareBufferManager::_freeUnusedBufferCopies()</a>.</p>

</div>
</div>
<a class="anchor" id="aa12ae6a67af715b2be80182bd05abb46"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::_notifyIndexBufferDestroyed" ref="aa12ae6a67af715b2be80182bd05abb46" args="(HardwareIndexBuffer *buf)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#aa12ae6a67af715b2be80182bd05abb46">Ogre::HardwareBufferManagerBase::_notifyIndexBufferDestroyed</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1HardwareIndexBuffer.html">HardwareIndexBuffer</a> *&#160;</td>
          <td class="paramname"><em>buf</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Notification that a hardware index buffer has been destroyed. </p>

<p>Reimplemented in <a class="el" href="classOgre_1_1HardwareBufferManager.html#aee835c8225ba41a1358db813ce080b0e">Ogre::HardwareBufferManager</a>.</p>

<p>Referenced by <a class="el" href="OgreHardwareBufferManager_8h_source.html#l00493">Ogre::HardwareBufferManager::_notifyIndexBufferDestroyed()</a>.</p>

</div>
</div>
<a class="anchor" id="a29b2e243bab8522ae27ec23268ea154a"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::_notifyVertexBufferDestroyed" ref="a29b2e243bab8522ae27ec23268ea154a" args="(HardwareVertexBuffer *buf)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a29b2e243bab8522ae27ec23268ea154a">Ogre::HardwareBufferManagerBase::_notifyVertexBufferDestroyed</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1HardwareVertexBuffer.html">HardwareVertexBuffer</a> *&#160;</td>
          <td class="paramname"><em>buf</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Notification that a hardware vertex buffer has been destroyed. </p>

<p>Reimplemented in <a class="el" href="classOgre_1_1HardwareBufferManager.html#a2b188dbba89b0210ad7359434aa87bee">Ogre::HardwareBufferManager</a>.</p>

<p>Referenced by <a class="el" href="OgreHardwareBufferManager_8h_source.html#l00488">Ogre::HardwareBufferManager::_notifyVertexBufferDestroyed()</a>.</p>

</div>
</div>
<a class="anchor" id="a507f064fdba0dd61a438f61a2dafac26"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::_releaseBufferCopies" ref="a507f064fdba0dd61a438f61a2dafac26" args="(bool forceFreeUnused=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a507f064fdba0dd61a438f61a2dafac26">Ogre::HardwareBufferManagerBase::_releaseBufferCopies</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>forceFreeUnused</em> = <code>false</code></td><td>)</td>
          <td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Internal method for releasing all temporary buffers which have been allocated using BLT_AUTOMATIC_RELEASE; is called by OGRE. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">forceFreeUnused</td><td>If true, free all unused temporary buffers. If false, auto detect and free all unused temporary buffers based on temporary buffers utilization. </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented in <a class="el" href="classOgre_1_1HardwareBufferManager.html#a8632cd79b8f18ed2b21bd6b474a49276">Ogre::HardwareBufferManager</a>.</p>

<p>Referenced by <a class="el" href="OgreHardwareBufferManager_8h_source.html#l00472">Ogre::HardwareBufferManager::_releaseBufferCopies()</a>.</p>

</div>
</div>
<a class="anchor" id="aabe7d6ac6a04013f106656c76a0eb222"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::allocateVertexBufferCopy" ref="aabe7d6ac6a04013f106656c76a0eb222" args="(const HardwareVertexBufferSharedPtr &amp;sourceBuffer, BufferLicenseType licenseType, HardwareBufferLicensee *licensee, bool copyData=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#aabe7d6ac6a04013f106656c76a0eb222">Ogre::HardwareBufferManagerBase::allocateVertexBufferCopy</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &amp;&#160;</td>
          <td class="paramname"><em>sourceBuffer</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a88f21df1e7ee330033812ddeba4a08fa">BufferLicenseType</a>&#160;</td>
          <td class="paramname"><em>licenseType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1HardwareBufferLicensee.html">HardwareBufferLicensee</a> *&#160;</td>
          <td class="paramname"><em>licensee</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>copyData</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Allocates a copy of a given vertex buffer. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This method allocates a temporary copy of an existing vertex buffer. This buffer is subsequently stored and can be made available for other purposes later without incurring the cost of construction / destruction. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">sourceBuffer</td><td>The source buffer to use as a copy </td></tr>
    <tr><td class="paramname">licenseType</td><td>The type of license required on this buffer - automatic release causes this class to release licenses every frame so that they can be reallocated anew. </td></tr>
    <tr><td class="paramname">licensee</td><td>Pointer back to the class requesting the copy, which must implement HardwareBufferLicense in order to be notified when the license expires. </td></tr>
    <tr><td class="paramname">copyData</td><td>If true, the current data is copied as well as the structure of the buffer </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented in <a class="el" href="classOgre_1_1HardwareBufferManager.html#a9061909fca1c96d50ddbeeee6df8a4d8">Ogre::HardwareBufferManager</a>.</p>

<p>Referenced by <a class="el" href="OgreHardwareBufferManager_8h_source.html#l00444">Ogre::HardwareBufferManager::allocateVertexBufferCopy()</a>.</p>

</div>
</div>
<a class="anchor" id="a55643b623b8168fb98c58ce39281a70e"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::createIndexBuffer" ref="a55643b623b8168fb98c58ce39281a70e" args="(HardwareIndexBuffer::IndexType itype, size_t numIndexes, HardwareBuffer::Usage usage, bool useShadowBuffer=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1HardwareIndexBufferSharedPtr.html">HardwareIndexBufferSharedPtr</a> <a class="el" href="classOgre_1_1D3D9HardwareBufferManagerBase.html#a55643b623b8168fb98c58ce39281a70e">Ogre::D3D9HardwareBufferManagerBase::createIndexBuffer</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1HardwareIndexBuffer.html#a25ba4923e015d46de162f7cc4c256326">HardwareIndexBuffer::IndexType</a>&#160;</td>
          <td class="paramname"><em>itype</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>numIndexes</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630">HardwareBuffer::Usage</a>&#160;</td>
          <td class="paramname"><em>usage</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>useShadowBuffer</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create a hardware vertex buffer. </p>

<p>Implements <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#ae46262b1cc1e8bfe136e9bb203894c41">Ogre::HardwareBufferManagerBase</a>.</p>

</div>
</div>
<a class="anchor" id="aff42262fe713059c776d8d17afd1515b"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::createRenderToVertexBuffer" ref="aff42262fe713059c776d8d17afd1515b" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__RenderSystem.html#ga00531851f476b9a8432258652828902a">RenderToVertexBufferSharedPtr</a> <a class="el" href="classOgre_1_1D3D9HardwareBufferManagerBase.html#aff42262fe713059c776d8d17afd1515b">Ogre::D3D9HardwareBufferManagerBase::createRenderToVertexBuffer</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create a render to vertex buffer. </p>

<p>Implements <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a830cd072c0e063e729b67201f04492a1">Ogre::HardwareBufferManagerBase</a>.</p>

</div>
</div>
<a class="anchor" id="ada99304b688c2ceff6fd4b8b63dad90f"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::createVertexBuffer" ref="ada99304b688c2ceff6fd4b8b63dad90f" args="(size_t vertexSize, size_t numVerts, HardwareBuffer::Usage usage, bool useShadowBuffer=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> <a class="el" href="classOgre_1_1D3D9HardwareBufferManagerBase.html#ada99304b688c2ceff6fd4b8b63dad90f">Ogre::D3D9HardwareBufferManagerBase::createVertexBuffer</a> </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>vertexSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>numVerts</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630">HardwareBuffer::Usage</a>&#160;</td>
          <td class="paramname"><em>usage</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>useShadowBuffer</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Creates a vertex buffer. </p>

<p>Implements <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a6009815139b407d20347dd3e2262e5ad">Ogre::HardwareBufferManagerBase</a>.</p>

</div>
</div>
<a class="anchor" id="a061290f70a7b145768a09030ac8684bf"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::createVertexBufferBinding" ref="a061290f70a7b145768a09030ac8684bf" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1VertexBufferBinding.html">VertexBufferBinding</a>* <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a061290f70a7b145768a09030ac8684bf">Ogre::HardwareBufferManagerBase::createVertexBufferBinding</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Creates a new <a class="el" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex declaration with the...">VertexBufferBinding</a>. </p>

<p>Reimplemented in <a class="el" href="classOgre_1_1HardwareBufferManager.html#a4d907dd6ed467886ca7df6a188b73d4d">Ogre::HardwareBufferManager</a>.</p>

<p>Referenced by <a class="el" href="OgreHardwareBufferManager_8h_source.html#l00427">Ogre::HardwareBufferManager::createVertexBufferBinding()</a>.</p>

</div>
</div>
<a class="anchor" id="a36d7b275f4a2b39b27f55ace09140d03"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::createVertexBufferBindingImpl" ref="a36d7b275f4a2b39b27f55ace09140d03" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1VertexBufferBinding.html">VertexBufferBinding</a>* <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a36d7b275f4a2b39b27f55ace09140d03">Ogre::HardwareBufferManagerBase::createVertexBufferBindingImpl</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected, virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Internal method for creates a new <a class="el" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex declaration with the...">VertexBufferBinding</a>, may be overridden by certain rendering APIs. </p>

</div>
</div>
<a class="anchor" id="aa8203be281c1d4f66efd3e5f9616962a"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::createVertexDeclaration" ref="aa8203be281c1d4f66efd3e5f9616962a" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a>* <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#aa8203be281c1d4f66efd3e5f9616962a">Ogre::HardwareBufferManagerBase::createVertexDeclaration</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Creates a new vertex declaration. </p>

<p>Reimplemented in <a class="el" href="classOgre_1_1HardwareBufferManager.html#a0d6a29a55a89d937cec4cbaa6c7e8b4b">Ogre::HardwareBufferManager</a>.</p>

<p>Referenced by <a class="el" href="OgreHardwareBufferManager_8h_source.html#l00416">Ogre::HardwareBufferManager::createVertexDeclaration()</a>.</p>

</div>
</div>
<a class="anchor" id="a2e213585f8c49d8b803859e5c73209ee"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::createVertexDeclarationImpl" ref="a2e213585f8c49d8b803859e5c73209ee" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a>* <a class="el" href="classOgre_1_1D3D9HardwareBufferManagerBase.html#a2e213585f8c49d8b803859e5c73209ee">Ogre::D3D9HardwareBufferManagerBase::createVertexDeclarationImpl</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Internal method for creates a new vertex declaration, may be overridden by certain rendering APIs. </p>

<p>Reimplemented from <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#ab3756b338f15ec08f13109ec3f8808a1">Ogre::HardwareBufferManagerBase</a>.</p>

</div>
</div>
<a class="anchor" id="a995a5db6b774e98b46c598dcb569f983"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::destroyAllBindings" ref="a995a5db6b774e98b46c598dcb569f983" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a995a5db6b774e98b46c598dcb569f983">Ogre::HardwareBufferManagerBase::destroyAllBindings</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected, virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Internal method for destroys all vertex buffer bindings. </p>

</div>
</div>
<a class="anchor" id="a4be16779dfe2b99fc3395bfe66ba4b4d"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::destroyAllDeclarations" ref="a4be16779dfe2b99fc3395bfe66ba4b4d" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a4be16779dfe2b99fc3395bfe66ba4b4d">Ogre::HardwareBufferManagerBase::destroyAllDeclarations</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected, virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Internal method for destroys all vertex declarations. </p>

</div>
</div>
<a class="anchor" id="a8f392b28a07b9f8f6b70f3020598acfe"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::destroyVertexBufferBinding" ref="a8f392b28a07b9f8f6b70f3020598acfe" args="(VertexBufferBinding *binding)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a8f392b28a07b9f8f6b70f3020598acfe">Ogre::HardwareBufferManagerBase::destroyVertexBufferBinding</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1VertexBufferBinding.html">VertexBufferBinding</a> *&#160;</td>
          <td class="paramname"><em>binding</em></td><td>)</td>
          <td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Destroys a <a class="el" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex declaration with the...">VertexBufferBinding</a>. </p>

<p>Reimplemented in <a class="el" href="classOgre_1_1HardwareBufferManager.html#af5abdc6a7e28634b759189e54f1e6fdd">Ogre::HardwareBufferManager</a>.</p>

<p>Referenced by <a class="el" href="OgreHardwareBufferManager_8h_source.html#l00432">Ogre::HardwareBufferManager::destroyVertexBufferBinding()</a>.</p>

</div>
</div>
<a class="anchor" id="a39d2f9bd9b2388498b2143fb7c24710c"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::destroyVertexBufferBindingImpl" ref="a39d2f9bd9b2388498b2143fb7c24710c" args="(VertexBufferBinding *binding)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a39d2f9bd9b2388498b2143fb7c24710c">Ogre::HardwareBufferManagerBase::destroyVertexBufferBindingImpl</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1VertexBufferBinding.html">VertexBufferBinding</a> *&#160;</td>
          <td class="paramname"><em>binding</em></td><td>)</td>
          <td><code> [protected, virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Internal method for destroys a <a class="el" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex declaration with the...">VertexBufferBinding</a>, may be overridden by certain rendering APIs. </p>

</div>
</div>
<a class="anchor" id="a95462f68508b75a7d87d0c5e496806fa"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::destroyVertexDeclaration" ref="a95462f68508b75a7d87d0c5e496806fa" args="(VertexDeclaration *decl)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a95462f68508b75a7d87d0c5e496806fa">Ogre::HardwareBufferManagerBase::destroyVertexDeclaration</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> *&#160;</td>
          <td class="paramname"><em>decl</em></td><td>)</td>
          <td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Destroys a vertex declaration. </p>

<p>Reimplemented in <a class="el" href="classOgre_1_1HardwareBufferManager.html#a8df941430aef9a6c87660655b51672a3">Ogre::HardwareBufferManager</a>.</p>

<p>Referenced by <a class="el" href="OgreHardwareBufferManager_8h_source.html#l00421">Ogre::HardwareBufferManager::destroyVertexDeclaration()</a>.</p>

</div>
</div>
<a class="anchor" id="aea810a50aa7e04aba62b15d6ba6417f9"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::destroyVertexDeclarationImpl" ref="aea810a50aa7e04aba62b15d6ba6417f9" args="(VertexDeclaration *decl)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1D3D9HardwareBufferManagerBase.html#aea810a50aa7e04aba62b15d6ba6417f9">Ogre::D3D9HardwareBufferManagerBase::destroyVertexDeclarationImpl</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> *&#160;</td>
          <td class="paramname"><em>decl</em></td><td>)</td>
          <td><code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Internal method for destroys a vertex declaration, may be overridden by certain rendering APIs. </p>

<p>Reimplemented from <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#af111248f2e13a5b6a49ca993a2e526e1">Ogre::HardwareBufferManagerBase</a>.</p>

</div>
</div>
<a class="anchor" id="ac3cb89b74c26e42415d599b59079f5d7"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::makeBufferCopy" ref="ac3cb89b74c26e42415d599b59079f5d7" args="(const HardwareVertexBufferSharedPtr &amp;source, HardwareBuffer::Usage usage, bool useShadowBuffer)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#ac3cb89b74c26e42415d599b59079f5d7">Ogre::HardwareBufferManagerBase::makeBufferCopy</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &amp;&#160;</td>
          <td class="paramname"><em>source</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630">HardwareBuffer::Usage</a>&#160;</td>
          <td class="paramname"><em>usage</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>useShadowBuffer</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Creates a new buffer as a copy of the source, does not copy data. </p>

</div>
</div>
<a class="anchor" id="a8357fe4fb4849772b94baa4bf47c7ded"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::operator delete" ref="a8357fe4fb4849772b94baa4bf47c7ded" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00095">95</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1c727e879a260c37b00ce5505fe8e144"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::operator delete" ref="a1c727e879a260c37b00ce5505fe8e144" args="(void *ptr, void *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00101">101</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="acb46d4b0a597156d9ba5abc39d127792"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::operator delete" ref="acb46d4b0a597156d9ba5abc39d127792" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00107">107</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a93e6a86dde5483c053ca0f2a85bbfd6c"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::operator delete[]" ref="a93e6a86dde5483c053ca0f2a85bbfd6c" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00112">112</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a595ea4c05da8aa987d3800e65d23355d"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::operator delete[]" ref="a595ea4c05da8aa987d3800e65d23355d" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00118">118</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a421b197ca3a38da17e2eb1531a645fa2"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::operator new" ref="a421b197ca3a38da17e2eb1531a645fa2" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00067">67</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac4bdf968b7b9af8a5239a27da73d5711"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::operator new" ref="ac4bdf968b7b9af8a5239a27da73d5711" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00072">72</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab78a921e54419be677839cdf15d1f0b8"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::operator new" ref="ab78a921e54419be677839cdf15d1f0b8" args="(size_t sz, void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>placement operator new </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00078">78</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4be37baef81876985aa1071ad5acc6dd"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::operator new[]" ref="a4be37baef81876985aa1071ad5acc6dd" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>array operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00085">85</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="afa2943846ba6a2b5824a12857139cf5e"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::operator new[]" ref="afa2943846ba6a2b5824a12857139cf5e" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00090">90</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1deff999bf2f7fa437609fca417810e9"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::registerVertexBufferSourceAndCopy" ref="a1deff999bf2f7fa437609fca417810e9" args="(const HardwareVertexBufferSharedPtr &amp;sourceBuffer, const HardwareVertexBufferSharedPtr &amp;copy)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a1deff999bf2f7fa437609fca417810e9">Ogre::HardwareBufferManagerBase::registerVertexBufferSourceAndCopy</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &amp;&#160;</td>
          <td class="paramname"><em>sourceBuffer</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &amp;&#160;</td>
          <td class="paramname"><em>copy</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Registers a vertex buffer as a copy of another. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This is useful for registering an existing buffer as a temporary buffer which can be allocated just like a copy. </dd></dl>

<p>Reimplemented in <a class="el" href="classOgre_1_1HardwareBufferManager.html#a763b65efa057185d7acbe073bf0e3610">Ogre::HardwareBufferManager</a>.</p>

<p>Referenced by <a class="el" href="OgreHardwareBufferManager_8h_source.html#l00437">Ogre::HardwareBufferManager::registerVertexBufferSourceAndCopy()</a>.</p>

</div>
</div>
<a class="anchor" id="ace31f1bc14e398d1379b1e50af9f87c3"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::releaseVertexBufferCopy" ref="ace31f1bc14e398d1379b1e50af9f87c3" args="(const HardwareVertexBufferSharedPtr &amp;bufferCopy)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#ace31f1bc14e398d1379b1e50af9f87c3">Ogre::HardwareBufferManagerBase::releaseVertexBufferCopy</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &amp;&#160;</td>
          <td class="paramname"><em>bufferCopy</em></td><td>)</td>
          <td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Manually release a vertex buffer copy for others to subsequently use. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Only required if the original call to allocateVertexBufferCopy included a licenseType of BLT_MANUAL_RELEASE. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">bufferCopy</td><td>The buffer copy. The caller is expected to delete or at least no longer use this reference, since another user may well begin to modify the contents of the buffer. </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented in <a class="el" href="classOgre_1_1HardwareBufferManager.html#a34bc652b029f856a5b130f850ba333a0">Ogre::HardwareBufferManager</a>.</p>

<p>Referenced by <a class="el" href="OgreHardwareBufferManager_8h_source.html#l00453">Ogre::HardwareBufferManager::releaseVertexBufferCopy()</a>.</p>

</div>
</div>
<a class="anchor" id="a6530263f486220aa3040129240d3caed"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::touchVertexBufferCopy" ref="a6530263f486220aa3040129240d3caed" args="(const HardwareVertexBufferSharedPtr &amp;bufferCopy)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a6530263f486220aa3040129240d3caed">Ogre::HardwareBufferManagerBase::touchVertexBufferCopy</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &amp;&#160;</td>
          <td class="paramname"><em>bufferCopy</em></td><td>)</td>
          <td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Tell engine that the vertex buffer copy intent to reuse. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd><a class="el" href="namespaceOgre.html">Ogre</a> internal keep an expired delay counter of BLT_AUTOMATIC_RELEASE buffers, when the counter count down to zero, it'll release for other purposes later. But you can use this function to reset the counter to the internal configured value, keep the buffer not get released for some frames. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">bufferCopy</td><td>The buffer copy. The caller is expected to keep this buffer copy for use. </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented in <a class="el" href="classOgre_1_1HardwareBufferManager.html#af83a478657dabe2d2e35f0d876abcc5b">Ogre::HardwareBufferManager</a>.</p>

<p>Referenced by <a class="el" href="OgreHardwareBufferManager_8h_source.html#l00460">Ogre::HardwareBufferManager::touchVertexBufferCopy()</a>.</p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a66f8e4f014fc41a52f35f7c0b03569e0"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::EXPIRED_DELAY_FRAME_THRESHOLD" ref="a66f8e4f014fc41a52f35f7c0b03569e0" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const size_t <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a66f8e4f014fc41a52f35f7c0b03569e0">Ogre::HardwareBufferManagerBase::EXPIRED_DELAY_FRAME_THRESHOLD</a><code> [static, protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Frame delay for BLT_AUTOMATIC_RELEASE temporary buffers. </p>

<p>Definition at line <a class="el" href="OgreHardwareBufferManager_8h_source.html#l00199">199</a> of file <a class="el" href="OgreHardwareBufferManager_8h_source.html">OgreHardwareBufferManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac5339ff98d67f523eb88f9d1b29567d9"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::mFreeTempVertexBufferMap" ref="ac5339ff98d67f523eb88f9d1b29567d9" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#ab1b16f5bb965056ed416ca0d7eedb991">FreeTemporaryVertexBufferMap</a> <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#ac5339ff98d67f523eb88f9d1b29567d9">Ogre::HardwareBufferManagerBase::mFreeTempVertexBufferMap</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Map of current available temp buffers. </p>

<p>Definition at line <a class="el" href="OgreHardwareBufferManager_8h_source.html#l00189">189</a> of file <a class="el" href="OgreHardwareBufferManager_8h_source.html">OgreHardwareBufferManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="a458d12d5abfa8d8971a4c4c6b214f799"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::mIndexBuffers" ref="a458d12d5abfa8d8971a4c4c6b214f799" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a2b2a1446c08ef1bb58c47987b62d83d0">IndexBufferList</a> <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a458d12d5abfa8d8971a4c4c6b214f799">Ogre::HardwareBufferManagerBase::mIndexBuffers</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreHardwareBufferManager_8h_source.html#l00122">122</a> of file <a class="el" href="OgreHardwareBufferManager_8h_source.html">OgreHardwareBufferManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="a811086c11e14fa760b42ea958884804e"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::mTempVertexBufferLicenses" ref="a811086c11e14fa760b42ea958884804e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#ac56a99f7b4b029db20fd8b94f1e82c13">TemporaryVertexBufferLicenseMap</a> <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a811086c11e14fa760b42ea958884804e">Ogre::HardwareBufferManagerBase::mTempVertexBufferLicenses</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Map of currently licensed temporary buffers. </p>

<p>Definition at line <a class="el" href="OgreHardwareBufferManager_8h_source.html#l00193">193</a> of file <a class="el" href="OgreHardwareBufferManager_8h_source.html">OgreHardwareBufferManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="a98d9ba3a449e791f89a53d7fcf89c00a"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::mUnderUsedFrameCount" ref="a98d9ba3a449e791f89a53d7fcf89c00a" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a98d9ba3a449e791f89a53d7fcf89c00a">Ogre::HardwareBufferManagerBase::mUnderUsedFrameCount</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Number of frames elapsed since temporary buffers utilization was above half the available. </p>

<p>Definition at line <a class="el" href="OgreHardwareBufferManager_8h_source.html#l00195">195</a> of file <a class="el" href="OgreHardwareBufferManager_8h_source.html">OgreHardwareBufferManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="a30d13bdd51fd0ffb1b2f5cc13bc15786"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::mVertexBufferBindings" ref="a30d13bdd51fd0ffb1b2f5cc13bc15786" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a44e20d0e3ca12fa67e5003266a87af52">VertexBufferBindingList</a> <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a30d13bdd51fd0ffb1b2f5cc13bc15786">Ogre::HardwareBufferManagerBase::mVertexBufferBindings</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreHardwareBufferManager_8h_source.html#l00128">128</a> of file <a class="el" href="OgreHardwareBufferManager_8h_source.html">OgreHardwareBufferManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="a6a99117e4adc55561ec0eb36617115a4"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::mVertexBuffers" ref="a6a99117e4adc55561ec0eb36617115a4" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#ac413284fee3eb42ef05be9a920da448b">VertexBufferList</a> <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#a6a99117e4adc55561ec0eb36617115a4">Ogre::HardwareBufferManagerBase::mVertexBuffers</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreHardwareBufferManager_8h_source.html#l00121">121</a> of file <a class="el" href="OgreHardwareBufferManager_8h_source.html">OgreHardwareBufferManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab93e6c8ebe86328233d604c78f9cbb7b"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::mVertexDeclarations" ref="ab93e6c8ebe86328233d604c78f9cbb7b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#ab3ae22ef96c13dfa02878d27d592f3bc">VertexDeclarationList</a> <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#ab93e6c8ebe86328233d604c78f9cbb7b">Ogre::HardwareBufferManagerBase::mVertexDeclarations</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreHardwareBufferManager_8h_source.html#l00127">127</a> of file <a class="el" href="OgreHardwareBufferManager_8h_source.html">OgreHardwareBufferManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="afd420f56dc09d1e9975179e2ffe824ca"></a><!-- doxytag: member="Ogre::D3D9HardwareBufferManagerBase::UNDER_USED_FRAME_THRESHOLD" ref="afd420f56dc09d1e9975179e2ffe824ca" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const size_t <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html#afd420f56dc09d1e9975179e2ffe824ca">Ogre::HardwareBufferManagerBase::UNDER_USED_FRAME_THRESHOLD</a><code> [static, protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Number of frames to wait before free unused temporary buffers. </p>

<p>Definition at line <a class="el" href="OgreHardwareBufferManager_8h_source.html#l00197">197</a> of file <a class="el" href="OgreHardwareBufferManager_8h_source.html">OgreHardwareBufferManager.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreD3D9HardwareBufferManager_8h_source.html">OgreD3D9HardwareBufferManager.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:15
</p>
</body>
</html>
